diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
index 286ceb6fe..efffcdb57 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
@@ -2,7 +2,6 @@ package org.useless.dragonfly.models.block.mojang;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightingCache;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColor;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.generic.BlockModelGeneric;
@@ -12,6 +11,7 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
@@ -52,14 +52,14 @@ public class StaticBlockModelMojang implements StaticBlockModel {
     }
 
     @Override
-    public boolean renderStandalone(@NotNull BlockModelGeneric<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, double x, double y, double z, int metadata, int lightmapCoord, @NotNull BlockColor color) {
+    public boolean renderStandalone(@NotNull BlockModelGeneric<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, double x, double y, double z, int metadata, byte lightIndex, @NotNull BlockColor color) {
         if (this.compiled.elements.length == 0) return false;
 
         tessellator.startDrawingQuads();
         for (int i = 0; i < this.compiled.elements.length; i++) {
             C_Element element = this.compiled.elements[i];
 
-            tessellator.setLightmapCoord1i(lightmapCoord);
+            tessellator.setLightmapCoord1i(lightIndex);
             for (int face = 0; face < element.faces; face++) {
                 IconCoordinate coordinate = element.textures[face];
 
@@ -255,10 +255,10 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 final int dirY = element.flip ? -direction.getOffsetY() : direction.getOffsetY();
                 final int dirZ = element.flip ? -direction.getOffsetZ() : direction.getOffsetZ();
 
-                final int lightmapCoordTopLeft;
-                final int lightmapCoordBottomLeft;
-                final int lightmapCoordBottomRight;
-                final int lightmapCoordTopRight;
+                final byte lightIndexTopLeft;
+                final byte lightIndexBottomLeft;
+                final byte lightIndexBottomRight;
+                final byte lightIndexTopRight;
 
                 LIGHTING_CACHE.setupCache(sourceModel.block, worldSource, blockPos);
 
@@ -286,30 +286,30 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     final boolean botLefT = LIGHTING_CACHE.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
                     final boolean botRigT = LIGHTING_CACHE.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
 
-                    final int lmcCen = getLightmap(dirX2, dirY2, dirZ2, element.lightEmission);
+                    final byte lmcCen = getLightIndex(dirX2, dirY2, dirZ2, element.lightEmission);
 
-                    final int lmcTop = topT ? lmcCen : getLightmap(dirX2 + topX, dirY2 + topY, dirZ2 + topZ, element.lightEmission);
-                    final int lmcBot = botT ? lmcCen : getLightmap(dirX2 - topX, dirY2 - topY, dirZ2 - topZ, element.lightEmission);
-                    final int lmcLef = lefT ? lmcCen : getLightmap(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ, element.lightEmission);
-                    final int lmcRig = rigT ? lmcCen : getLightmap(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ, element.lightEmission);
+                    final byte lmcTop = topT ? lmcCen : getLightIndex(dirX2 + topX, dirY2 + topY, dirZ2 + topZ, element.lightEmission);
+                    final byte lmcBot = botT ? lmcCen : getLightIndex(dirX2 - topX, dirY2 - topY, dirZ2 - topZ, element.lightEmission);
+                    final byte lmcLef = lefT ? lmcCen : getLightIndex(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ, element.lightEmission);
+                    final byte lmcRig = rigT ? lmcCen : getLightIndex(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ, element.lightEmission);
 
-                    final int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : getLightmap(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ, element.lightEmission));
-                    final int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : getLightmap(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ, element.lightEmission));
-                    final int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : getLightmap(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ, element.lightEmission));
-                    final int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : getLightmap(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ, element.lightEmission));
+                    final byte lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : getLightIndex(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ, element.lightEmission));
+                    final byte lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : getLightIndex(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ, element.lightEmission));
+                    final byte lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : getLightIndex(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ, element.lightEmission));
+                    final byte lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : getLightIndex(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ, element.lightEmission));
 
-                    lightmapCoordTopLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
-                    lightmapCoordTopRight = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
-                    lightmapCoordBottomLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
-                    lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
+                    lightIndexTopLeft = LightIndexHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
+                    lightIndexTopRight = LightIndexHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
+                    lightIndexBottomLeft = LightIndexHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
+                    lightIndexBottomRight = LightIndexHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
                 } else {
-                    final int lmc;
+                    final byte lmc;
                     if (!isFullCube) {
-                        lmc = getLightmap(0, 0, 0, element.lightEmission);
+                        lmc = getLightIndex(0, 0, 0, element.lightEmission);
                     } else {
-                        lmc = getLightmap(dirX, dirY, dirZ, element.lightEmission);
+                        lmc = getLightIndex(dirX, dirY, dirZ, element.lightEmission);
                     }
-                    lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
+                    lightIndexTopLeft = lightIndexBottomLeft = lightIndexBottomRight = lightIndexTopRight = lmc;
                 }
 
                 float lightTR;
@@ -396,21 +396,6 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 final float lbl = lefP * bl + (1 - lefP) * br;
                 final float lbr = rigP * bl + (1 - rigP) * br;
                 final float ltr = rigP * tl + (1 - rigP) * tr;
-                colorRedTopLeft *= ltl;
-                colorGreenTopLeft *= ltl;
-                colorBlueTopLeft *= ltl;
-
-                colorRedBottomLeft *= lbl;
-                colorGreenBottomLeft *= lbl;
-                colorBlueBottomLeft *= lbl;
-
-                colorRedBottomRight *= lbr;
-                colorGreenBottomRight *= lbr;
-                colorBlueBottomRight *= lbr;
-
-                colorRedTopRight *= ltr;
-                colorGreenTopRight *= ltr;
-                colorBlueTopRight *= ltr;
 
                 final int offset = face * 4;
 
@@ -436,7 +421,8 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 Vector2fc uvsTL = element.vertexUvs[offset + VERTEX_TOP_LEFT];
                 if (uvlock) uvsTL = rotateUV(uvsTL, rotX, rotY, rotZ, element.directions[face], this.vertUV);
                 tessellator.setColorOpaque3f(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
-                tessellator.setLightmapCoord1i(lightmapCoordTopLeft);
+                tessellator.setLightmapCoord1i(lightIndexTopLeft);
+                tessellator.setShade1i((int) (ltl * 0xFF));
                 tessellator.addVertexWithUV(
                     posTL.x() + blockPos.x() + xOff,
                     posTL.y() + blockPos.y() + yOff,
@@ -455,7 +441,8 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 Vector2fc uvsBL = element.vertexUvs[offset + VERTEX_BOTTOM_LEFT];
                 if (uvlock) uvsBL = rotateUV(uvsBL, rotX, rotY, rotZ, element.directions[face], this.vertUV);
                 tessellator.setColorOpaque3f(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
-                tessellator.setLightmapCoord1i(lightmapCoordBottomLeft);
+                tessellator.setLightmapCoord1i(lightIndexBottomLeft);
+                tessellator.setShade1i((int) (lbl * 0xFF));
                 tessellator.addVertexWithUV(
                     posBL.x() + blockPos.x() + xOff,
                     posBL.y() + blockPos.y() + yOff,
@@ -474,7 +461,8 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 Vector2fc uvsBR = element.vertexUvs[offset + VERTEX_BOTTOM_RIGHT];
                 if (uvlock) uvsBR = rotateUV(uvsBR, rotX, rotY, rotZ, element.directions[face], this.vertUV);
                 tessellator.setColorOpaque3f(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
-                tessellator.setLightmapCoord1i(lightmapCoordBottomRight);
+                tessellator.setLightmapCoord1i(lightIndexBottomRight);
+                tessellator.setShade1i((int) (lbr * 0xFF));
                 tessellator.addVertexWithUV(
                     posBR.x() + blockPos.x() + xOff,
                     posBR.y() + blockPos.y() + yOff,
@@ -493,7 +481,8 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 Vector2fc uvsTR = element.vertexUvs[offset + VERTEX_TOP_RIGHT];
                 if (uvlock) uvsTR = rotateUV(uvsTR, rotX, rotY, rotZ, element.directions[face], this.vertUV);
                 tessellator.setColorOpaque3f(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
-                tessellator.setLightmapCoord1i(lightmapCoordTopRight);
+                tessellator.setLightmapCoord1i(lightIndexTopRight);
+                tessellator.setShade1i((int) (ltr * 0xFF));
                 tessellator.addVertexWithUV(
                     posTR.x() + blockPos.x() + xOff,
                     posTR.y() + blockPos.y() + yOff,
@@ -607,11 +596,11 @@ public class StaticBlockModelMojang implements StaticBlockModel {
         return Math.max(LIGHTING_CACHE.getBrightness(relX, relY, relZ), min);
     }
 
-    protected int getLightmap(int relX, int relY, int relZ, int min) {
-        int coord = LIGHTING_CACHE.getLightmapCoord(relX, relY, relZ);
-        int block = LightmapHelper.getBlockLightFromCoord(coord);
+    protected byte getLightIndex(int relX, int relY, int relZ, int min) {
+        byte coord = LIGHTING_CACHE.getLightIndex(relX, relY, relZ);
+        int block = LightIndexHelper.blockLightFromIndex(coord);
         if (block < min) {
-            coord = LightmapHelper.setBlocklightValue(coord, min);
+            coord = LightIndexHelper.setBlockLight(coord, min);
         }
         return coord;
     }
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
index a74e34b68..b5f0c970a 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
@@ -9,6 +9,7 @@ import net.minecraft.client.render.tessellator.RenderBuffer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.uniform.UniformBlockManager;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -110,7 +111,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
         GLRenderer.pushFrame();
         GLRenderer.setShader(Shaders.ENTITY);
         GLRenderer.globalSetUniforms(Shaders.ENTITY);
-        Shaders.ENTITY.uniformVec2f("uLightmap", GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+        Shaders.ENTITY.uniformVec2f("uLightmap", (LightIndexHelper.blockLightFromIndex(GLRenderer.getLightIndex()) + 0.5f)/16f, (LightIndexHelper.skyLightFromIndex(GLRenderer.getLightIndex()) + 0.5f)/16f);
         {
             GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, UniformBlockManager.BLOCK_ENTITY_BONES.ubo);
             UniformBlockManager.BLOCK_ENTITY_BONES.buffer.clear();
diff --git a/game/client/src/main/resources/shaders/color_world.vsh b/game/client/src/main/resources/shaders/color_world.vsh
index 8a30d9bfa..789a284c8 100644
--- a/game/client/src/main/resources/shaders/color_world.vsh
+++ b/game/client/src/main/resources/shaders/color_world.vsh
@@ -1,7 +1,7 @@
 #version 410 core
 layout (location = 0) in vec3 aPos;
 layout (location = 1) in vec4 aColor;
-layout (location = 3) in vec2 aLightmap;
+layout (location = 3) in float aLightmap;
 layout (location = 4) in vec3 aNormal;
 
 out vec4 Color;
@@ -24,12 +24,17 @@ layout (std140) uniform Matrices {
     mat4 viewInv;
 } matrices;
 
+vec2 unpackLightCoord() {
+    int asInt = int(aLightmap);
+    return vec2(((asInt & 0xF) + 0.5)/16.0, (((asInt & 0xF0) >> 4) + 0.5)/16.0);
+}
+
 void main() {
     vec4 p = vec4(aPos, 1);
     gl_Position = matrices.projection * matrices.view * model * p;
 
     Color = aColor;
-    LightMapCoord = aLightmap;
+    LightMapCoord = unpackLightCoord();
 
     vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
     float dir1 = max(0.0, dot(norm, lightSourcePosition1));
diff --git a/game/client/src/main/resources/shaders/font.vsh b/game/client/src/main/resources/shaders/font.vsh
index 66ffb5e4c..573276518 100644
--- a/game/client/src/main/resources/shaders/font.vsh
+++ b/game/client/src/main/resources/shaders/font.vsh
@@ -5,7 +5,7 @@ layout (location = 2) in float aShift;
 layout (location = 3) in vec4 aColor;
 layout (location = 4) in vec2 aUv;
 layout (location = 5) in vec2 aUvSizes;
-layout (location = 6) in vec2 aLightmap;
+layout (location = 6) in float aLightmap;
 
 out VS_OUT {
     vec2 size;
@@ -18,6 +18,11 @@ out VS_OUT {
 
 uniform float uZ;
 
+vec2 unpackLightCoord() {
+    int asInt = int(aLightmap);
+    return vec2(((asInt & 0xF) + 0.5)/16.0, (((asInt & 0xF0) >> 4) + 0.5)/16.0);
+}
+
 void main() {
     gl_Position = vec4(aPos, uZ, 1);
 
@@ -26,5 +31,5 @@ void main() {
     vs_out.color = aColor;
     vs_out.uv = aUv/256.0;
     vs_out.uvSizes = aUvSizes/256.0;
-    vs_out.lightmap = aLightmap;
+    vs_out.lightmap = unpackLightCoord();
 }
diff --git a/game/client/src/main/resources/shaders/item.fsh b/game/client/src/main/resources/shaders/item.fsh
new file mode 100644
index 000000000..03bdcc37c
--- /dev/null
+++ b/game/client/src/main/resources/shaders/item.fsh
@@ -0,0 +1,91 @@
+#version 410 core
+
+out vec4 FragColor;
+
+in vec4 Color;
+in vec2 TexCoord;
+in vec2 LightMapCoord;
+in vec3 Light;
+in vec3 Norm;
+
+uniform float uAlphaTest;
+uniform vec4 uColor;
+uniform vec2 uViewPortSize;
+
+layout (std140) uniform FogState {
+    vec4 color;
+    int mode;
+    float start;
+    float end;
+    float density;
+} fogState;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+uniform sampler2D colortex;
+uniform sampler2D lighttex;
+uniform sampler2D emmisivetex;
+uniform sampler2D colormasktex;
+
+float distance() {
+    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
+    fragPos /= fragPos.w;
+
+    return length(fragPos.xyz);
+}
+
+// Taken from https://github.com/hughsk/glsl-fog
+float fogFactorLinear() {
+    return 1.0 - clamp(((fogState.end - (distance())) / (fogState.end - fogState.start)), 0.0, 1.0);
+}
+
+float fogFactorExp() {
+    return 1.0 - clamp(exp(-fogState.density * (distance())), 0.0, 1.0);
+}
+
+float fogFactorExp2() {
+    float LOG2 = -1.442695;
+    float d = fogState.density * (distance());
+    return 1.0 - clamp(exp2(d * d * LOG2), 0.0, 1.0);
+}
+
+
+vec4 computeFog(vec4 color) {
+    float f = 0;
+    if (fogState.mode == 0) { // Linear
+        f = fogFactorLinear();
+    }
+    else if (fogState.mode == 1) { // EXP
+        f = fogFactorExp();
+    }
+    else if (fogState.mode == 2) { // EXP2
+        f = fogFactorExp2();
+    }
+    return vec4(mix(color.rgb, fogState.color.rgb, f), color.a);
+}
+
+void main() {
+    vec4 emmisiveColor = texture(emmisivetex, TexCoord);
+    vec4 lightColor = texture(lighttex, vec2(max(LightMapCoord.x, emmisiveColor.r), max(LightMapCoord.y, emmisiveColor.g)));
+    vec4 texColor = texture(colortex, TexCoord);
+    vec4 maskColor = texture(colormasktex, TexCoord);
+
+    vec4 c = vec4(mix(vec3(1, 1, 1), Color.rgb, maskColor.r), 1) * uColor;
+
+    vec4 postColor = texColor * c * lightColor;
+    vec4 litColor = vec4(postColor.rgb * clamp(Light, 0, 1), postColor.a);
+    //    vec4 litColor = vec4(abs(Norm), 1f);
+
+    vec4 fColor = computeFog(litColor);
+
+
+    FragColor = fColor;
+    if (FragColor.a < uAlphaTest) {
+        discard;
+    }
+}
diff --git a/game/client/src/main/resources/shaders/item.vsh b/game/client/src/main/resources/shaders/item.vsh
new file mode 100644
index 000000000..676551563
--- /dev/null
+++ b/game/client/src/main/resources/shaders/item.vsh
@@ -0,0 +1,48 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec4 aColor;
+layout (location = 2) in vec2 aUV;
+layout (location = 3) in float aLightmap;
+layout (location = 4) in vec3 aNormal;
+
+out vec4 Color;
+out vec2 TexCoord;
+out vec2 LightMapCoord;
+out vec3 Light;
+out vec3 Norm;
+
+uniform mat4 normalTransform;
+uniform vec4 lightModelAmbient;
+uniform vec4 lightSourcePosition1;
+uniform vec4 lightSourcePosition2;
+uniform vec4 lightSourceDiffuse1;
+uniform vec4 lightSourceDiffuse2;
+
+uniform mat4 model;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+vec2 unpackLightCoord() {
+    int asInt = int(aLightmap);
+    return vec2(((asInt & 0xF) + 0.5)/16.0, (((asInt & 0xF0) >> 4) + 0.5)/16.0);
+}
+
+void main() {
+    vec4 p = vec4(aPos, 1);
+    gl_Position = matrices.projection * matrices.view * model * p;
+
+    TexCoord = aUV;
+    Color = aColor;
+    LightMapCoord = unpackLightCoord();
+
+    Norm = normalize(aNormal);
+    vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
+    float dir1 = max(0.0, dot(norm, lightSourcePosition1));
+    float dir2 = max(0.0, dot(norm, lightSourcePosition2));
+    Light = (lightModelAmbient + lightSourceDiffuse1 * (dir1 + dir2)).xyz;
+}
diff --git a/game/client/src/main/resources/shaders/lod.fsh b/game/client/src/main/resources/shaders/lod.fsh
new file mode 100644
index 000000000..b39576477
--- /dev/null
+++ b/game/client/src/main/resources/shaders/lod.fsh
@@ -0,0 +1,8 @@
+#version 330 core
+out vec4 FragColor;
+
+in vec4 Color;
+
+void main() {
+    FragColor = Color;
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/lod.gsh b/game/client/src/main/resources/shaders/lod.gsh
new file mode 100644
index 000000000..9571aa103
--- /dev/null
+++ b/game/client/src/main/resources/shaders/lod.gsh
@@ -0,0 +1,205 @@
+#version 330 core
+layout (points) in;
+layout (triangle_strip, max_vertices = 36) out;
+
+in VS_OUT {
+    vec3 color;
+    uint faces;
+} gs_in[];
+
+out vec4 Color;
+
+uniform mat4 model;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+#define FACES_MASK_BOTTOM 0x01u
+#define FACES_MASK_TOP 0x02u
+#define FACES_MASK_NORTH 0x04u
+#define FACES_MASK_SOUTH 0x08u
+#define FACES_MASK_WEST 0x10u
+#define FACES_MASK_EAST 0x20u
+
+/*
+ * for north/south faces:
+ *   Y  A  B
+ *   ^  C  D
+ *      >  X
+ * for east/west faces:
+ *   Y  B  A
+ *   ^  D  C
+ *      X  <
+ * for top/bottom faces:
+ *   Z  A  B
+ *   ^  C  D
+ *      >  X
+ * A = 0, 1
+ * B = 1, 1
+ * C = 0, 0
+ * D = 1, 0
+ */
+
+#define Aa 0.0
+#define Ab 1.0
+#define Ba 1.0
+#define Bb 1.0
+#define Ca 0.0
+#define Cb 0.0
+#define Da 1.0
+#define Db 0.0
+
+#define BR_BOTTOM 0.5
+#define BR_TOP 1.0
+#define BR_NORTH_SOUTH 0.8
+#define BR_EAST_WEST 0.6
+
+void main() {
+    // uint color = gs_in[0].packedColorFaces & 0x00FFFFFFu;
+    // float r = ((color >> 0) & 0xFFu) / 255.0;
+    // float g = ((color >> 8) & 0xFFu) / 255.0;
+    // float b = ((color >> 16) & 0xFFu) / 255.0;
+    // uint faces = ((gs_in[0].packedColorFaces >> 24) & 0xFFu);
+    // vec3 cc = vec3(r, g, b);
+    uint faces = gs_in[0].faces;
+    vec3 cc = gs_in[0].color;
+
+    if (faces > 0u) {
+        faces = 0xFFu;
+    }
+
+    if ((faces & FACES_MASK_BOTTOM) > 0u) { // min Y
+        Color = vec4(cc * BR_BOTTOM, 1.0);
+
+        // C
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Ca, 0.0, Cb, 0.0));
+        EmitVertex();
+
+        // D
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Da, 0.0, Db, 0.0));
+        EmitVertex();
+
+        // A
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Aa, 0.0, Ab, 0.0));
+        EmitVertex();
+
+        // B
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Ba, 0.0, Bb, 0.0));
+        EmitVertex();
+
+        EndPrimitive();
+    }
+
+    if ((faces & FACES_MASK_TOP) > 0u) { // max Y
+        Color = vec4(cc * BR_TOP, 1.0);
+
+        // C
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Ca, 1.0, Cb, 0.0));
+        EmitVertex();
+
+        // A
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Aa, 1.0, Ab, 0.0));
+        EmitVertex();
+
+        // D
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Da, 1.0, Db, 0.0));
+        EmitVertex();
+
+        // B
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Ba, 1.0, Bb, 0.0));
+        EmitVertex();
+        
+        EndPrimitive();
+    }
+
+    if ((faces & FACES_MASK_NORTH) > 0u) { // min Z
+        Color = vec4(cc * BR_NORTH_SOUTH, 1.0);
+
+        // C
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Ca, Cb, 0.0, 0.0));
+        EmitVertex();
+
+        // A
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Aa, Ab, 0.0, 0.0));
+        EmitVertex();
+
+        // D
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Da, Db, 0.0, 0.0));
+        EmitVertex();
+
+        // B
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Ba, Bb, 0.0, 0.0));
+        EmitVertex();
+        
+        EndPrimitive();
+    }
+
+    if ((faces & FACES_MASK_SOUTH) > 0u) { // max Z
+        Color = vec4(cc * BR_NORTH_SOUTH, 1.0);
+
+        // C
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Ca, Cb, 1.0, 0.0));
+        EmitVertex();
+
+        // D
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Da, Db, 1.0, 0.0));
+        EmitVertex();
+
+        // A
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Aa, Ab, 1.0, 0.0));
+        EmitVertex();
+
+        // B
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(Ba, Bb, 1.0, 0.0));
+        EmitVertex();
+        
+        EndPrimitive();
+    }
+
+    if ((faces & FACES_MASK_WEST) > 0u) { // min X
+        Color = vec4(cc * BR_EAST_WEST, 1.0);
+
+        // C
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(0.0, Ca, Cb, 0.0));
+        EmitVertex();
+
+        // A
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(0.0, Aa, Ab, 0.0));
+        EmitVertex();
+
+        // D
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(0.0, Da, Db, 0.0));
+        EmitVertex();
+
+        // B
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(0.0, Ba, Bb, 0.0));
+        EmitVertex();
+        
+        EndPrimitive();
+    }
+
+    if ((faces & FACES_MASK_EAST) > 0u) { // max X
+        Color = vec4(cc * BR_EAST_WEST, 1.0);
+
+        // C
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(1.0, Ca, Cb, 0.0));
+        EmitVertex();
+
+        // D
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(1.0, Da, Db, 0.0));
+        EmitVertex();
+
+        // A
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(1.0, Aa, Ab, 0.0));
+        EmitVertex();
+
+        // B
+        gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(1.0, Ba, Bb, 0.0));
+        EmitVertex();
+        
+        EndPrimitive();
+    }
+}
diff --git a/game/client/src/main/resources/shaders/lod.vsh b/game/client/src/main/resources/shaders/lod.vsh
new file mode 100644
index 000000000..7bfed510b
--- /dev/null
+++ b/game/client/src/main/resources/shaders/lod.vsh
@@ -0,0 +1,16 @@
+#version 330 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec3 aColor;
+layout (location = 2) in uint aFaces;
+
+out VS_OUT {
+    vec3 color;
+    uint faces;
+} vs_out;
+
+void main() {
+    gl_Position = vec4(aPos, 1.0);
+
+    vs_out.color = aColor;
+    vs_out.faces = aFaces;
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/particle.fsh b/game/client/src/main/resources/shaders/particle.fsh
index 0208364de..f7a726d72 100644
--- a/game/client/src/main/resources/shaders/particle.fsh
+++ b/game/client/src/main/resources/shaders/particle.fsh
@@ -3,15 +3,82 @@ out vec4 FragColor;
 
 in vec4 Color;
 in vec2 TexCoord;
-in vec2 Lightmap;
+in vec2 LightMapCoord;
 
 uniform float uAlphaTest;
+uniform vec4 uColor;
+uniform vec2 uViewPortSize;
+
+layout (std140) uniform FogState {
+    vec4 color;
+    int mode;
+    float start;
+    float end;
+    float density;
+} fogState;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 uniform sampler2D colortex;
 uniform sampler2D lighttex;
+uniform sampler2D emmisivetex;
+uniform sampler2D colormasktex;
+
+float distance() {
+    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
+    fragPos /= fragPos.w;
+
+    return length(fragPos.xyz);
+}
+
+// Taken from https://github.com/hughsk/glsl-fog
+float fogFactorLinear() {
+    return 1.0 - clamp(((fogState.end - (distance())) / (fogState.end - fogState.start)), 0.0, 1.0);
+}
+
+float fogFactorExp() {
+    return 1.0 - clamp(exp(-fogState.density * (distance())), 0.0, 1.0);
+}
+
+float fogFactorExp2() {
+    float LOG2 = -1.442695;
+    float d = fogState.density * (distance());
+    return 1.0 - clamp(exp2(d * d * LOG2), 0.0, 1.0);
+}
+
+
+vec4 computeFog(vec4 color) {
+    float f = 0;
+    if (fogState.mode == 0) { // Linear
+        f = fogFactorLinear();
+    }
+    else if (fogState.mode == 1) { // EXP
+        f = fogFactorExp();
+    }
+    else if (fogState.mode == 2) { // EXP2
+        f = fogFactorExp2();
+    }
+    return vec4(mix(color.rgb, fogState.color.rgb, f), color.a);
+}
 
 void main() {
-    FragColor = texture(colortex, TexCoord) * texture(lighttex, Lightmap) * Color;
+    vec4 emmisiveColor = texture(emmisivetex, TexCoord);
+    vec4 lightColor = texture(lighttex, vec2(max(LightMapCoord.x, emmisiveColor.r), max(LightMapCoord.y, emmisiveColor.g)));
+    vec4 texColor = texture(colortex, TexCoord);
+    vec4 maskColor = texture(colormasktex, TexCoord);
+
+    vec4 c = vec4(mix(vec3(1, 1, 1), Color.rgb, maskColor.r), 1) * uColor;
+
+    vec4 postColor = texColor * c * lightColor;
+
+    vec4 fColor = computeFog(postColor);
+
+    FragColor = fColor;
     if (FragColor.a < uAlphaTest) {
         discard;
     }
diff --git a/game/client/src/main/resources/shaders/particle.gsh b/game/client/src/main/resources/shaders/particle.gsh
index fe109c241..290510268 100644
--- a/game/client/src/main/resources/shaders/particle.gsh
+++ b/game/client/src/main/resources/shaders/particle.gsh
@@ -12,7 +12,7 @@ in VS_OUT {
 
 out vec4 Color;
 out vec2 TexCoord;
-out vec2 Lightmap;
+out vec2 LightMapCoord;
 
 uniform mat4 model;
 layout (std140) uniform Matrices {
@@ -24,7 +24,7 @@ layout (std140) uniform Matrices {
 
 void main() {
     Color = gs_in[0].color;
-    Lightmap = gs_in[0].lightmap;
+    LightMapCoord = gs_in[0].lightmap;
 
     TexCoord = gs_in[0].uv;
     gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + matrices.viewInv * vec4(-gs_in[0].scale,  gs_in[0].scale, 0.0, 0.0));
